local ZoneTextPlus = _G.CreateFrame("Frame", "InitiumNovum_ZoneTextPlus")

ZoneTextPlus.obj = _G.LibStub("LibDataBroker-1.1"):NewDataObject("Initium Novum - ZoneTextPlus", {type = "data source"})

_G.LibStub("LibShefkiTimer-1.0"):Embed(ZoneTextPlus)

function ZoneTextPlus:Update()
    local return_zone_text = ""

    local x, y = _G.GetPlayerMapPosition("player")
    local speed = _G.GetUnitSpeed("player")
    local speed_text = string.format(" %.0f", speed * 100 / 7)
    local coords_text = string.format("( %.2f | %.2f )", x * 100, y * 100)
    local real_zone_text = _G.GetRealZoneText()
    local sub_zone_text = _G.GetSubZoneText()
    
    if real_zone_text == nil then real_zone_text = "" end
    if sub_zone_text == nil then sub_zone_text = "" end

    if sub_zone_text == "" then
        return_zone_text = real_zone_text
    else
        return_zone_text = real_zone_text .. " - " .. sub_zone_text
    end

    return_zone_text = return_zone_text .. " " .. coords_text .. " " .. speed_text

    self.obj.text = return_zone_text
end


ZoneTextPlus:SetScript("OnEvent", function()
    ZoneTextPlus:ScheduleRepeatingTimer("Update", 0.1)
end)

ZoneTextPlus:RegisterEvent("PLAYER_ENTERING_WORLD")